import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import PouchDB from "pouchdb-browser";
export default function createPouchDB(_ref) {
  var synchronousAPIInitialSubscriptionCleanupDelay = _ref.synchronousAPIInitialSubscriptionCleanupDelay,
      maxListeners = _ref.maxListeners,
      options = _objectWithoutProperties(_ref, ["synchronousAPIInitialSubscriptionCleanupDelay", "maxListeners"]);

  var db = new PouchDB( // PouchDB constructor modifies the options object. Make sure options is a
  // copy so the original object remains untouched.
  options);

  if (maxListeners) {
    db.setMaxListeners(maxListeners);
  }

  return Object.assign(db, {
    reactPouchDBOptions: {
      synchronousAPIInitialSubscriptionCleanupDelay: synchronousAPIInitialSubscriptionCleanupDelay
    }
  });
}
//# sourceMappingURL=createPouchDB.js.map