"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createPouchDB;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _pouchdb = _interopRequireDefault(require("pouchdb"));

function createPouchDB(_ref) {
  var synchronousAPIInitialSubscriptionCleanupDelay = _ref.synchronousAPIInitialSubscriptionCleanupDelay,
      maxListeners = _ref.maxListeners,
      options = (0, _objectWithoutProperties2.default)(_ref, ["synchronousAPIInitialSubscriptionCleanupDelay", "maxListeners"]);
  var db = new _pouchdb.default( // PouchDB constructor modifies the options object. Make sure options is a
  // copy so the original object remains untouched.
  options);

  if (maxListeners) {
    db.setMaxListeners(maxListeners);
  }

  return Object.assign(db, {
    reactPouchDBOptions: {
      synchronousAPIInitialSubscriptionCleanupDelay: synchronousAPIInitialSubscriptionCleanupDelay
    }
  });
}
//# sourceMappingURL=createPouchDB.js.map